function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }
function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }
function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }
function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) arr2[i] = arr[i]; return arr2; }
function _iterableToArrayLimit(r, l) { var t = null == r ? null : "undefined" != typeof Symbol && r[Symbol.iterator] || r["@@iterator"]; if (null != t) { var e, n, i, u, a = [], f = !0, o = !1; try { if (i = (t = t.call(r)).next, 0 === l) { if (Object(t) !== t) return; f = !1; } else for (; !(f = (e = i.call(t)).done) && (a.push(e.value), a.length !== l); f = !0); } catch (r) { o = !0, n = r; } finally { try { if (!f && null != t.return && (u = t.return(), Object(u) !== u)) return; } finally { if (o) throw n; } } return a; } }
function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }
import React from 'react';
import styled from 'styled-components';
import { useSelectMachineFromContext } from '../context';
var StyledListItemWrapper = styled.li.withConfig({
  displayName: "ListItem__StyledListItemWrapper",
  componentId: "sc-1ucvxmv-0"
})(["width:100%;outline:none;"]);
export var ListItemWrapper = React.forwardRef(function (props, ref) {
  var _useSelectMachineFrom = useSelectMachineFromContext(),
    _useSelectMachineFrom2 = _slicedToArray(_useSelectMachineFrom, 1),
    current = _useSelectMachineFrom2[0];
  var selected = props.option.options ? false : current.context.selectedItems.includes(props.option) || current.context.selectedItems.some(function (x) {
    var _x$options;
    return x.value === props.option.value || ((_x$options = x.options) === null || _x$options === void 0 ? void 0 : _x$options.some(function (y) {
      return y.value === props.option.value;
    }));
  });
  var Component = props.component;
  return React.createElement(StyledListItemWrapper, {
    ref: ref,
    onClick: props.onClick,
    role: "option",
    "aria-selected": selected,
    "aria-disabled": props.option.disabled,
    id: "".concat(props.id, "-option-").concat(props.index),
    tabIndex: 0
  }, React.createElement(Component, {
    index: props.index
  }));
});